stages:
  - build
  - deploy
  - test
  
build:
  stage: build
  image: maven
  script:
    - chmod +x mvnw
    - ./mvnw package
  artifacts:
    paths:
      - target/main-0.0.1-SNAPSHOT.jar

deploy:
  stage: deploy
  image: ubuntu
  script:
    - 'apt-get update -y && apt-get install openssh-client git -y'
    - eval $(ssh-agent -s)
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
    - touch ~/.ssh/known_hosts
    - ssh-keyscan 51.250.64.206 >> ~/.ssh/known_hosts
    - scp ./target/main-0.0.1-SNAPSHOT.jar minina@51.250.64.206:/home/minina/app/main-0.0.1-SNAPSHOT.jar
    - ssh minina@51.250.64.206 "docker rm -f lab1_sqr" 
    - ssh minina@51.250.64.206 "docker run -d -p 8080:8080 -v /home/minina/app:/app --name lab1_sqr --restart always --entrypoint java openjdk:8 -jar /app/main-0.0.1-SNAPSHOT.jar"
  dependencies: 
    - build

test:
  stage: test
  image: curlimages/curl
  script:
    - curl http://51.250.64.206:8080/hello/
  dependencies: 
    - deploy